package drawingapp;

/**
 *
 * @author ShabanaY
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseListener;
import java.awt.geom.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;
import java.awt.geom.Arc2D;
import java.awt.image.BufferedImage;
import java.awt.print.PageFormat;
import javafx.print.Printer;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.plaf.metal.MetalTabbedPaneUI;

public class Drawing extends JFrame 
{         
  // Monitors what shape to draw next
  int currentAction = 1;
  
  // Makes sure the float for slider only shows 2 digits
  DecimalFormat transDec = new DecimalFormat("#.##");

  // Transparency value of the shape
  float transVal = 1.0f;

  // Makes sure the float for brush slider only shows 2 numbers
  DecimalFormat brushDec = new DecimalFormat("##");

  // Brush size value of the brush
  int brushVal = 1;

  // Default stroke and fill colors
  Color strokeColor = Color.BLACK;
  Color fillColor = Color.BLACK;
  
  // Creates new tab name in the tabbed panel
  String tabName = "Unsaved ";

  // Gets tab counts in the tabbed panel index
  int tabIdx;
  int tabIndex;
  
  // Creates new label for the profile link
  JLabelLink myLink = new JLabelLink();
  
  // Instance of the main drawing panel
  Panel2 pl2 = new Panel2();
  
  // Creats a file chooser and log for the save action
  JFileChooser fc = new JFileChooser();
  
  /**
   * Creates new form Drawing
   */
  public Drawing() 
  {
    initComponents();
  }

  /**
   * This method is called from within the constructor to initialize the form. WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    msgLabel = new javax.swing.JLabel();
    mainPanel = new javax.swing.JPanel();
    btnPanel = new javax.swing.JPanel();
    brushBtn = new javax.swing.JButton();
    lineBtn = new javax.swing.JButton();
    rectBtn = new javax.swing.JButton();
    ellipseBtn = new javax.swing.JButton();
    clearBtn = new javax.swing.JButton();
    strokeBtn = new javax.swing.JButton();
    fillBtn = new javax.swing.JButton();
    brushLabel = new javax.swing.JLabel();
    brushSlider = new javax.swing.JSlider();
    transLabel = new javax.swing.JLabel();
    transSlider = new javax.swing.JSlider();
    tabbedPane = new javax.swing.JTabbedPane();
    middleSeparator = new javax.swing.JSeparator();
    topSeparator = new javax.swing.JSeparator();
    mainMenuBar = new javax.swing.JMenuBar();
    fileMenu = new javax.swing.JMenu();
    newMenu = new javax.swing.JMenuItem();
    exitMenu = new javax.swing.JMenuItem();
    shapesMenu = new javax.swing.JMenu();
    brushMenu = new javax.swing.JMenuItem();
    lineMenu = new javax.swing.JMenuItem();
    rectangleMenu = new javax.swing.JMenuItem();
    ellipseMenu = new javax.swing.JMenuItem();
    circleMenu = new javax.swing.JMenuItem();
    arcMenu = new javax.swing.JMenuItem();
    roundRecMenu = new javax.swing.JMenuItem();
    saveMenu = new javax.swing.JMenu();
    saveFileMenu = new javax.swing.JMenuItem();
    printMenu = new javax.swing.JMenu();
    printFileMenu = new javax.swing.JMenuItem();
    helpMenu = new javax.swing.JMenu();
    InstrMenu = new javax.swing.JMenuItem();
    featMenu = new javax.swing.JMenuItem();
    aboutProgramMenu = new javax.swing.JMenuItem();
    aboutProgrammerMenu = new javax.swing.JMenuItem();
    versionMenu = new javax.swing.JMenuItem();

    setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
    setTitle("Drawing Application");
    setName("mainFrame"); // NOI18N
    setPreferredSize(new java.awt.Dimension(1080, 720));
    setResizable(false);

    msgLabel.setForeground(new java.awt.Color(255, 0, 102));
    msgLabel.setToolTipText("User messages appear here.");
    msgLabel.setAutoscrolls(true);
    msgLabel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    msgLabel.setFocusable(false);
    msgLabel.setRequestFocusEnabled(false);

    brushBtn.setText("Brush");
    brushBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        brushBtnActionPerformed(evt);
      }
    });

    lineBtn.setText("Line");
    lineBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        lineBtnActionPerformed(evt);
      }
    });

    rectBtn.setText("Rectangle");
    rectBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        rectBtnActionPerformed(evt);
      }
    });

    ellipseBtn.setText("Ellipse");
    ellipseBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        ellipseBtnActionPerformed(evt);
      }
    });

    clearBtn.setText("Clear");
    clearBtn.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(java.awt.event.MouseEvent evt) {
        clearBtnMouseClicked(evt);
      }
    });

    strokeBtn.setText("Stroke");
    strokeBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        strokeBtnActionPerformed(evt);
      }
    });

    fillBtn.setText("Fill");
    fillBtn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        fillBtnActionPerformed(evt);
      }
    });

    brushLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
    brushLabel.setText("Brush Size");
    brushLabel.setMaximumSize(new java.awt.Dimension(59, 14));
    brushLabel.setMinimumSize(new java.awt.Dimension(59, 14));

    brushSlider.setMaximum(24);
    brushSlider.setMinimum(1);
    brushSlider.setValue(1);
    brushSlider.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    brushSlider.setEnabled(false);
    brushSlider.setMaximumSize(new java.awt.Dimension(36, 23));
    brushSlider.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        brushSliderStateChanged(evt);
      }
    });

    transLabel.setText("Transparent");

    transSlider.setValue(100);
    transSlider.setBorder(javax.swing.BorderFactory.createEtchedBorder());
    transSlider.setEnabled(false);
    transSlider.setMaximumSize(new java.awt.Dimension(36, 23));
    transSlider.addChangeListener(new javax.swing.event.ChangeListener() {
      public void stateChanged(javax.swing.event.ChangeEvent evt) {
        transSliderStateChanged(evt);
      }
    });

    javax.swing.GroupLayout btnPanelLayout = new javax.swing.GroupLayout(btnPanel);
    btnPanel.setLayout(btnPanelLayout);
    btnPanelLayout.setHorizontalGroup(
      btnPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(btnPanelLayout.createSequentialGroup()
        .addContainerGap()
        .addGroup(btnPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(btnPanelLayout.createSequentialGroup()
            .addComponent(brushLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(brushSlider, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE))
          .addGroup(btnPanelLayout.createSequentialGroup()
            .addComponent(brushBtn)
            .addGap(18, 18, 18)
            .addComponent(lineBtn)
            .addGap(18, 18, 18)
            .addComponent(rectBtn)
            .addGap(18, 18, 18)
            .addComponent(ellipseBtn)))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 67, Short.MAX_VALUE)
        .addGroup(btnPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
          .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, btnPanelLayout.createSequentialGroup()
            .addComponent(clearBtn)
            .addGap(18, 18, 18)
            .addComponent(strokeBtn)
            .addGap(18, 18, 18)
            .addComponent(fillBtn))
          .addGroup(btnPanelLayout.createSequentialGroup()
            .addComponent(transLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(transSlider, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
        .addContainerGap())
    );
    btnPanelLayout.setVerticalGroup(
      btnPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, btnPanelLayout.createSequentialGroup()
        .addGap(0, 0, 0)
        .addGroup(btnPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
          .addComponent(brushBtn)
          .addComponent(lineBtn)
          .addComponent(rectBtn)
          .addComponent(ellipseBtn)
          .addComponent(strokeBtn)
          .addComponent(fillBtn)
          .addComponent(clearBtn))
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
        .addGroup(btnPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
          .addComponent(brushSlider, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(brushLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(transSlider, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
          .addComponent(transLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
    );

    tabbedPane.setUI(new CustomTabbedPaneUI());

    middleSeparator.setForeground(new java.awt.Color(102, 102, 102));

    javax.swing.GroupLayout mainPanelLayout = new javax.swing.GroupLayout(mainPanel);
    mainPanel.setLayout(mainPanelLayout);
    mainPanelLayout.setHorizontalGroup(
      mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(middleSeparator, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 647, Short.MAX_VALUE)
      .addComponent(tabbedPane, javax.swing.GroupLayout.Alignment.TRAILING)
      .addComponent(btnPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
    );
    mainPanelLayout.setVerticalGroup(
      mainPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(mainPanelLayout.createSequentialGroup()
        .addGap(0, 0, 0)
        .addComponent(btnPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        .addComponent(middleSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(tabbedPane, javax.swing.GroupLayout.PREFERRED_SIZE, 547, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addGap(46, 46, 46))
    );

    fileMenu.setText("File");
    fileMenu.setToolTipText("File");

    newMenu.setText("New");
    newMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        newMenuActionPerformed(evt);
      }
    });
    fileMenu.add(newMenu);

    exitMenu.setText("Exit");
    exitMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        exitMenuActionPerformed(evt);
      }
    });
    fileMenu.add(exitMenu);

    mainMenuBar.add(fileMenu);

    shapesMenu.setText("Shapes");
    shapesMenu.setToolTipText("Shapes");

    brushMenu.setText("Brush");
    brushMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        brushMenuActionPerformed(evt);
      }
    });
    shapesMenu.add(brushMenu);

    lineMenu.setText("Line");
    lineMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        lineMenuActionPerformed(evt);
      }
    });
    shapesMenu.add(lineMenu);

    rectangleMenu.setText("Rectangle");
    rectangleMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        rectangleMenuActionPerformed(evt);
      }
    });
    shapesMenu.add(rectangleMenu);

    ellipseMenu.setText("Ellipse");
    ellipseMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        ellipseMenuActionPerformed(evt);
      }
    });
    shapesMenu.add(ellipseMenu);

    circleMenu.setText("Circle");
    circleMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        circleMenuActionPerformed(evt);
      }
    });
    shapesMenu.add(circleMenu);

    arcMenu.setText("Arc");
    arcMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        arcMenuActionPerformed(evt);
      }
    });
    shapesMenu.add(arcMenu);

    roundRecMenu.setText("Round Rectangle");
    roundRecMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        roundRecMenuActionPerformed(evt);
      }
    });
    shapesMenu.add(roundRecMenu);

    mainMenuBar.add(shapesMenu);

    saveMenu.setText("Save");
    saveMenu.setToolTipText("Save");
    saveMenu.setNextFocusableComponent(printMenu);

    saveFileMenu.setText("Save File");
    saveFileMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        saveFileMenuActionPerformed(evt);
      }
    });
    saveMenu.add(saveFileMenu);

    mainMenuBar.add(saveMenu);

    printMenu.setText("Print");
    printMenu.setToolTipText("Print");
    printMenu.setNextFocusableComponent(helpMenu);

    printFileMenu.setText("Print File");
    printFileMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        printFileMenuActionPerformed(evt);
      }
    });
    printMenu.add(printFileMenu);

    mainMenuBar.add(printMenu);

    helpMenu.setText("Help!");
    helpMenu.setToolTipText("Help!");

    InstrMenu.setText("Basic Instructions");
    InstrMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        InstrMenuActionPerformed(evt);
      }
    });
    helpMenu.add(InstrMenu);

    featMenu.setText("Additional Features");
    featMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        featMenuActionPerformed(evt);
      }
    });
    helpMenu.add(featMenu);

    aboutProgramMenu.setText("About Program");
    aboutProgramMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        aboutProgramMenuActionPerformed(evt);
      }
    });
    helpMenu.add(aboutProgramMenu);

    aboutProgrammerMenu.setText("About Programmer");
    aboutProgrammerMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        aboutProgrammerMenuActionPerformed(evt);
      }
    });
    helpMenu.add(aboutProgrammerMenu);

    versionMenu.setText("Version");
    versionMenu.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent evt) {
        versionMenuActionPerformed(evt);
      }
    });
    helpMenu.add(versionMenu);

    mainMenuBar.add(helpMenu);

    setJMenuBar(mainMenuBar);

    javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
    getContentPane().setLayout(layout);
    layout.setHorizontalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addComponent(mainPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
      .addComponent(msgLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
      .addComponent(topSeparator)
    );
    layout.setVerticalGroup(
      layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
      .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
        .addComponent(msgLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(topSeparator, javax.swing.GroupLayout.PREFERRED_SIZE, 9, javax.swing.GroupLayout.PREFERRED_SIZE)
        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
        .addComponent(mainPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 642, javax.swing.GroupLayout.PREFERRED_SIZE))
    );

    getAccessibleContext().setAccessibleDescription("");

    pack();
  }// </editor-fold>//GEN-END:initComponents

  private void transSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_transSliderStateChanged
    pl2.transSlider();
  }//GEN-LAST:event_transSliderStateChanged

  private void brushSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_brushSliderStateChanged
    pl2.brushSlider();
  }//GEN-LAST:event_brushSliderStateChanged

  private void brushBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_brushBtnActionPerformed
    brush();
  }//GEN-LAST:event_brushBtnActionPerformed

  private void lineBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lineBtnActionPerformed
    line();
  }//GEN-LAST:event_lineBtnActionPerformed

  private void rectBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rectBtnActionPerformed
    rectangle();
  }//GEN-LAST:event_rectBtnActionPerformed

  private void ellipseBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ellipseBtnActionPerformed
    ellipse();
  }//GEN-LAST:event_ellipseBtnActionPerformed

  private void strokeBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_strokeBtnActionPerformed
    pl2.strokeColor();
  }//GEN-LAST:event_strokeBtnActionPerformed

  private void fillBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fillBtnActionPerformed
    pl2.fillColor();
  }//GEN-LAST:event_fillBtnActionPerformed

  private void clearBtnMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_clearBtnMouseClicked
    pl2.clearBtn();
  }//GEN-LAST:event_clearBtnMouseClicked
    
  private void newMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_newMenuActionPerformed
    pl2.newDrawing();
  }//GEN-LAST:event_newMenuActionPerformed

  private void exitMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuActionPerformed
    TimedExit tx = new TimedExit();
    tx.exit();
  }//GEN-LAST:event_exitMenuActionPerformed

  private void aboutProgramMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutProgramMenuActionPerformed
    JOptionPane.showMessageDialog(null, "This is a simple painting and drawing program made by Yasmeen Shabana. \nIt was made for week 7-8 assignment of OOP course with Java.", 
              "About This Program", JOptionPane.INFORMATION_MESSAGE);
  }//GEN-LAST:event_aboutProgramMenuActionPerformed

  private void aboutProgrammerMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutProgrammerMenuActionPerformed
    SwingUtilities.invokeLater(() -> 
    {
      new JLabelLink().setVisible(true);
    });
  }//GEN-LAST:event_aboutProgrammerMenuActionPerformed

  private void brushMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_brushMenuActionPerformed
    brush();
  }//GEN-LAST:event_brushMenuActionPerformed

  private void lineMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lineMenuActionPerformed
    line();
  }//GEN-LAST:event_lineMenuActionPerformed

  private void rectangleMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rectangleMenuActionPerformed
    rectangle();
  }//GEN-LAST:event_rectangleMenuActionPerformed

  private void ellipseMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ellipseMenuActionPerformed
    ellipse();
  }//GEN-LAST:event_ellipseMenuActionPerformed

  private void circleMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_circleMenuActionPerformed
    circle();
  }//GEN-LAST:event_circleMenuActionPerformed

  private void arcMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_arcMenuActionPerformed
    arc();
  }//GEN-LAST:event_arcMenuActionPerformed

  private void roundRecMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_roundRecMenuActionPerformed
    roundRectangle();
  }//GEN-LAST:event_roundRecMenuActionPerformed

  private void InstrMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_InstrMenuActionPerformed
    JOptionPane.showMessageDialog(null, "Basic Instructions: \n"
            + "Step 1: Go to File menu and click New, this will create a new tab in the drawing board. \n"
            + "Step 2: Select the shape you want to draw by clicking the buttons at the top area. \n"
            + "Step 3: Drag the mouse over the drawing board then release it to draw the required shape. \n"
            , "Basic Instructions", JOptionPane.INFORMATION_MESSAGE);
  }//GEN-LAST:event_InstrMenuActionPerformed

  private void featMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_featMenuActionPerformed
    JOptionPane.showMessageDialog(null, "Additional feature: \n"
            + "- Change the brush size by moving the brush size slider. \n"
            + "- Change the level of transparency by moving the transparent slider. \n"
            + "- Select the stroke color by pressing the stroke button. \n"
            + "- Select the fill color by pressing the fill button. \n"
            + "- You can create and use up to five drawing boards at the same time. \n"
            + "- Choose between the shapes by clicking the relevant button or select from the Shapes menu. \n"
            , "Additional Feature", JOptionPane.INFORMATION_MESSAGE);
  }//GEN-LAST:event_featMenuActionPerformed

  private void versionMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_versionMenuActionPerformed
    JOptionPane.showMessageDialog(null,
            "This software was made by NetBeans IDE and NetBeans Platform \n"
            + "that are based on software from netbeans.org, which has been dual licensed \n"
            + "under the Common Development and Distribution License (CDDL) \n"
            + "and the GNU General Public License version 2 with Classpath exception."
            , "Drawing Application version 1.0", JOptionPane.INFORMATION_MESSAGE);
  }//GEN-LAST:event_versionMenuActionPerformed

  private void printFileMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_printFileMenuActionPerformed
    printComponenet();
  }//GEN-LAST:event_printFileMenuActionPerformed

  private void saveFileMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveFileMenuActionPerformed
    saveFile();
  }//GEN-LAST:event_saveFileMenuActionPerformed

// Customise the tab header to add a close button
class CustomTabbedPaneUI extends MetalTabbedPaneUI
{
  Rectangle xRect;
  
  @Override
  protected void installListeners() 
  {
      super.installListeners();
      tabPane.addMouseListener(new MyMouseHandler());
   }

  @Override
  protected void paintTab(Graphics g, int tabPlacement,
                          Rectangle[] rects, int tabIndex,
                          Rectangle iconRect, Rectangle textRect) 
  {
    super.paintTab(g, tabPlacement, rects, tabIndex, iconRect, textRect);

    Font f = g.getFont();
    g.setFont(new Font("Courier", Font.BOLD, 10));
    FontMetrics fm = g.getFontMetrics(g.getFont());
    int charWidth = fm.charWidth('x');
    int maxAscent = fm.getMaxAscent();
    g.drawString("x", textRect.x + textRect.width-3, textRect.y + textRect.height-3);
    g.drawRect(textRect.x+textRect.width-5,
               textRect.y+textRect.height-maxAscent, charWidth+2, maxAscent-1);
    xRect = new Rectangle(textRect.x+textRect.width-5,
               textRect.y+textRect.height-maxAscent, charWidth+2, maxAscent-1);
    g.setFont(f);
  }
  
  // Action for the close button in the tab header
  public class MyMouseHandler extends MouseAdapter 
  {
    @Override
    public void mousePressed(MouseEvent e) 
    {
      if (tabIdx <= 0)
      {
        transSlider.setEnabled(false);
        brushSlider.setEnabled(false);
        msgLabel.setText("  Drawing board is invisible again. You know what to do.");
      }
       
      else 
      {
        System.out.println(e);
        if (xRect.contains(e.getPoint()))
        {
        JTabbedPane tabPane = (JTabbedPane)e.getSource();
        tabIndex = tabForCoordinate(tabPane, e.getX(), e.getY());   

        tabPane.remove(tabIndex);
        }
      }
    }
  }
}
  
  // Creates a custom panel for the drawing board
  class Panel2 extends JPanel 
  { 
  // Contains all of the rules for drawing
  Graphics2D graphSettings;

  // Color iterators to cycle through strokes and fills
  Iterator<Color> strokeCounter;
  Iterator<Color> fillCounter;

  // Iterator for transparency
  Iterator<Float> transCounter;

  // Iterator for brush size
  Iterator<Integer> brushCounter;
    
  // ArrayLists that contain each shape drawn along with that shapes stroke and fill  
  ArrayList<Shape> shapes = new ArrayList<>();
  ArrayList<Color> shapeFill = new ArrayList<>();
  ArrayList<Color> shapeStroke = new ArrayList<>();
  ArrayList<Float> transPercent = new ArrayList<>();
  ArrayList<Integer> brushPercent = new ArrayList<>();
  Point drawStart;
  Point drawEnd;
  
  Panel2() 
  {
    // set a preferred size for the custom panel.
    this.setPreferredSize(new Dimension(640,400));
    this.addMouseListener(listener1);
    this.addMouseMotionListener(listener2);
  }                         
  
  @Override
  public void paint(Graphics g)
  { 
    // Class used to define the shapes
    graphSettings = (Graphics2D)g;

    // Antialiasing cleans up the jagged lines and defines rendering rules
    graphSettings.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
    
    // Defines the default background
    graphSettings.setBackground(Color.WHITE);
    
    // Defines the line width of the stroke
    graphSettings.setStroke(new BasicStroke(4));

    // Iterators created to cycle through strokes and fills
    strokeCounter = shapeStroke.iterator();
    fillCounter = shapeFill.iterator();

    // Iterator for transparency
    transCounter = transPercent.iterator();

    // Iterator for brush size
    brushCounter = brushPercent.iterator();
    
    if (shapes != null)
    {
      for (Shape s : shapes)
      {
        // Sets the shapes transparency value
        graphSettings.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, transCounter.next()));

        // Grabs the next stroke from the color arraylist
        graphSettings.setPaint(strokeCounter.next());
        graphSettings.draw(s);

        // Grabs the next fill from the color arraylist
        graphSettings.setPaint(fillCounter.next());
        graphSettings.fill(s);
      }
    }
    
    // Guide shape used for drawing
    if (drawStart != null && drawEnd != null)
    {
      // Makes the guide shape transparent
      graphSettings.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER, 0.40f));

      // Make guide shape gray while drawing
      graphSettings.setPaint(Color.LIGHT_GRAY);

      Shape aShape = null;

      if (currentAction == 2)
      {
        aShape = drawLine(drawStart.x, drawStart.y, drawEnd.x, drawEnd.y);
      } 

      else if (currentAction == 3)
      {
        aShape = drawRectangle(drawStart.x, drawStart.y, drawEnd.x, drawEnd.y);
      } 

      else if (currentAction == 4) 
      {
        aShape = drawEllipse(drawStart.x, drawStart.y, drawEnd.x, drawEnd.y);
      }
      
      else if (currentAction == 5) 
      {
        aShape = drawCircle(drawStart.x, drawStart.y, drawEnd.x, drawEnd.y);
      }
      
      else if (currentAction == 6) 
      {
        aShape = drawArc(drawStart.x, drawStart.y, drawEnd.x, drawEnd.y);
      }

      else if (currentAction == 7) 
      {
        aShape = drawRoundRectangle(drawStart.x, drawStart.y, drawEnd.x, drawEnd.y, 12, 12);
      }

      graphSettings.draw(aShape);
    }
    tabbedPane.repaint();
  }
  
  private void newDrawing() 
  {                                   
    transSlider.setEnabled(true);
    brushSlider.setEnabled(true);
    msgLabel.setText("  Brush is selected by default. Click the buttons below or check the Shapes menu to try different shapes.");
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx < 5)
    { 
      // Creates drawing panel for each new file
      JPanel newDrawingPanel = new Panel2();
      
      // Adds the new created drawing panel to the tabbed panel
      tabbedPane.add((String)tabName + tabIdx + "   ", newDrawingPanel);
      
      // Sets the focus of the tabbed panel to the latest created tab
      tabbedPane.setSelectedIndex(tabbedPane.getTabCount()-1);

      tabIdx++;
    }   

    else
    {
      JOptionPane.showMessageDialog(null, "Number of opened tabs exceeds 5.\nPlease close some tabs in order to make new ones", 
              "Drawing Application Error Message", JOptionPane.ERROR_MESSAGE);
    }
  }   
  
  private void clearBtn()
  {
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  There are no drawing boards. You need to create a drawing before you can clear it.");
    }
    
    else
    {
      // Removes all the shapes, tabs and reset the colors and the sliders to default values
      shapes.clear();
      tabbedPane.removeAll();    
      transSlider.setValue(100);
      brushSlider.setValue(0);
      strokeColor = Color.BLACK;
      fillColor = Color.BLACK;

      msgLabel.setText("  Drawing board is invisible again. You know what to do.");
    }
  }
  
  private void transSlider()
  {
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing.");
    }
    
    else
    {
      msgLabel.setText("  You can select transparency from 0 to 1. Remember, 0 makes your drawings disappear!");
      // Change the value for the label next to the transparency slider
      // Use decimal format to make sure only 2 decimals are displayed
      transLabel.setText("Transparent: " + transDec.format(transSlider.getValue() * .01));

      // Set the value for transparency for every shape drawn after
      transVal = (float) (transSlider.getValue() * .01);
    }
  }
  
  private void brushSlider() 
  {     
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing.");
    }
    
    else
    {
      msgLabel.setText("  You can change the brush size from 1 to 24.");
      // Change the value for the label next to the brush size slider
      // Use decimal format to make sure only 2 decimals are displayed
      brushLabel.setText("Brush Size: " + brushDec.format(brushSlider.getValue()));

      // Set the value for brush size for the brush
      brushVal = (int) (brushSlider.getValue());
    }
  }    
  
  private void strokeColor()
  {                                          
    msgLabel.setText("  Select your favourite stroke color.");
    strokeColor = JColorChooser.showDialog(null, "Pick a Stroke", Color.BLACK);
  }  
  
  private void fillColor() 
  {                                        
    msgLabel.setText("  Select your favourite fill color.");
    fillColor = JColorChooser.showDialog(null, "Pick a Fill", Color.BLACK);
  } 
  
  MouseListener listener1 = new MouseAdapter() 
  {
    @Override
    public void mousePressed(MouseEvent evt) 
    {                                          
      if(currentAction != 1)
      {
      // When the mouse is pressed get x & y position
      drawStart = new Point(evt.getX(), evt.getY());
      drawEnd = drawStart;
      }
      tabbedPane.repaint();
    }                                         
  
    @Override
    public void mouseReleased(MouseEvent evt) 
    {                                           
      if(currentAction != 1)
      {
        // Create a new shape using the starting x & y and finishing x & y coordinates
        Shape aShape = null;

        if (currentAction == 2)
        {
          // Create a new line using x & y coordinates
          aShape = drawLine(drawStart.x, drawStart.y, evt.getX(), evt.getY());
        } 

        else if (currentAction == 3)
        {
          // Create a new rectangle using x & y coordinates
          aShape = drawRectangle(drawStart.x, drawStart.y, evt.getX(), evt.getY());
        } 

        else if (currentAction == 4) 
        {
          // Create a new ellipse using x & y coordinates
          aShape = drawEllipse(drawStart.x, drawStart.y, evt.getX(), evt.getY());
        }
        
        else if (currentAction == 5) 
        {
          // Create a new circle using x & y coordinates
          aShape = drawCircle(drawStart.x, drawStart.y, evt.getX(), evt.getY());
        }
        
       else if (currentAction == 6) 
        {
          // Create a new arc using x & y coordinates
          aShape = drawArc(drawStart.x, drawStart.y, evt.getX(), evt.getY());
        }

        else if (currentAction == 7) 
        {
          // Create a new rounded rectangle using x & y coordinates
          aShape = drawRoundRectangle(drawStart.x, drawStart.y, evt.getX(), evt.getY(), 20, 20);
        }

        // Add shapes, fills and colors to ArrayLists
        shapes.add(aShape);
        shapeFill.add(fillColor);
        shapeStroke.add(strokeColor);

        // Add transparency percentage value to ArrayList
        transPercent.add(transVal);

        // Add brush percentage size value to ArrayList
        brushPercent.add(brushVal);

        drawStart = null;
        drawEnd = null;
      }
      tabbedPane.repaint();
    }
  };
  
  MouseMotionListener listener2 = new MouseAdapter() 
  {
    @Override
    public void mouseDragged(MouseEvent evt) 
    {                                          
      if(currentAction == 1)
      {
        int x = evt.getX();
        int y = evt.getY();

        Shape aShape = null;

        // Make stroke and fill equal
        strokeColor = fillColor;

        aShape = drawBrush(x, y, brushVal, brushVal);

        shapes.add(aShape);
        shapeFill.add(fillColor);
        shapeStroke.add(strokeColor);

        // Add the transparency value
        transPercent.add(transVal);

        // Add the transparency value
        brushPercent.add(brushVal);      
      } 

      // Get the end x & y position after the mouse is dragged
      drawEnd = new Point(evt.getX(), evt.getY());
    tabbedPane.repaint();
    }    
    };
  }
  
  class TimedExit 
  {
    Timer timer = new Timer();
    TimerTask exitApp = new TimerTask() 
    {
      @Override
      public void run() 
      {
        System.exit(0);
      }
    };

    public void exit() 
    {
      msgLabel.setText("  This program will exit in 5 seconds. See you next time.");
      timer.schedule(exitApp, new Date(System.currentTimeMillis()+5*1000));
    }
  }
  
  private void brush() 
  {                                         
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
    }
    
    else
    {
      currentAction = 1;
      msgLabel.setText("  Nothing like a free style drawing with a brush! For more shapes, check the shapes menu.");
    }
  }                                        
  
  private void line() 
  {                                        
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
    }
    
    else
    {
    currentAction = 2;
    msgLabel.setText("  So you want to draw some lines. Great choice! For more shapes, check the shapes menu.");
    }
  }                                       

  private void rectangle() 
  {                                        
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
    }
    
    else
    {
      currentAction = 3;
      msgLabel.setText("  How about some rectangles! For more shapes, check the shapes menu.");
    }
  }                                       

  private void ellipse() 
  {                                           
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
    }
    
    else
    {
      currentAction = 4;
      msgLabel.setText("  Let's draw an ellipse or two, shall we?! For more shapes, check the shapes menu.");
    }
  }   
    
  private void circle() 
  {                                           
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
    }
    
    else
    {
      currentAction = 5;
      msgLabel.setText("  Yes! finally drawing some circles! For more shapes, check the shapes menu.");
    }
  }   
  
  private void arc() 
  {                                           
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
    }
    
    else
    {
      currentAction = 6;
      msgLabel.setText("  Arcs just remind me of Arc de Triomphe in France, don't you agree?");
    }
  }   
  
  private void roundRectangle()
  {                                           
    tabIdx = tabbedPane.getTabCount();
    if(tabIdx <= 0)
    { 
      msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
    }
    
    else
    {
      currentAction = 7;
      msgLabel.setText("  Now you can try the rounded corners rectangle. For more shapes, check the shapes menu.");
    }
  }   
  
  private Ellipse2D.Float drawBrush(int x1, int y1, int brushStrokeWidth, int brushStrokeHeight)
  {    
    return new Ellipse2D.Float(x1, y1, brushStrokeWidth, brushStrokeHeight);
  }
  
  private Line2D.Float drawLine(int x1, int y1, int x2, int y2)
  {
    return new Line2D.Float(x1, y1, x2, y2);
  }
  
  private Rectangle2D.Float drawRectangle(int x1, int y1, int x2, int y2)
  {
    // Get the top left hand corner for the shape, Math.min returns the points closest to 0
    int x = Math.min(x1, x2);
    int y = Math.min(y1, y2);

    // Gets the difference between the coordinates
    int width = Math.abs(x1 - x2);
    int height = Math.abs(y1 - y2);

    return new Rectangle2D.Float(x, y, width, height);
  }

  private Ellipse2D.Float drawEllipse(int x1, int y1, int x2, int y2)
  {
    // Get the top left hand corner for the shape, Math.min returns the points closest to 0
    int x = Math.min(x1, x2);
    int y = Math.min(y1, y2);
    
    // Gets the difference between the coordinates
    int width = Math.abs(x1 - x2);
    int height = Math.abs(y1 - y2);

    return new Ellipse2D.Float(x, y, width, height);
  }
  
  // Manipulates the existing Ellipse method to draw a circle
  private Ellipse2D.Float drawCircle(int x1, int y1, int x2, int y2)
  {
    // Get the top left hand corner for the shape, Math.min returns the points closest to 0
    int x = Math.min(x1, x2);
    int y = Math.min(y1, y2);
    
    // Gets the difference between the coordinates
    int width = Math.abs(x1 - x2);

    return new Ellipse2D.Float(x, y, width, width);
  }
  
  private Arc2D.Float drawArc(int x1, int y1, int x2, int y2)
  {
    // Get the top left hand corner for the shape, Math.min returns the points closest to 0
    int x = Math.min(x1, x2);
    int y = Math.min(y1, y2);
    
    // Gets the difference between the coordinates
    int width = Math.abs(x1 - x2);
    int height = Math.abs(y1 - y2);

    return new Arc2D.Float(x, y, width, height, 0, 135, Arc2D.OPEN);
  }

  private RoundRectangle2D.Float drawRoundRectangle(int x1, int y1, int x2, int y2, int arcw, int arch)
  {
    // Get the top left hand corner for the shape, Math.min returns the points closest to 0
    int x = Math.min(x1, x2);
    int y = Math.min(y1, y2);

    // Gets the difference between the coordinates
    int width = Math.abs(x1 - x2);
    int height = Math.abs(y1 - y2);

    arcw = arch = 20;
    
    return new RoundRectangle2D.Float(x, y, width, height, arcw, arch);
  }
  
   public void msgBox()
  {
    msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing.");
  }
   
  public void printComponenet()
  {    
    if(tabIdx <= 0)
    {
      msgLabel.setText("  There are no drawings for printing.");
    }
    
    else 
    {
      PrinterJob pj = PrinterJob.getPrinterJob();
      pj.setJobName(" Print Component ");

      pj.setPrintable (new Printable() 
      { 
        @Override
        public int print(Graphics pg, PageFormat pf, int pageNum)
        {
          if (pageNum > 0)
          {
            return Printable.NO_SUCH_PAGE;
          }

          else 
          {
            Graphics2D g2 = (Graphics2D) pg;
            g2.translate(pf.getImageableX(), pf.getImageableY());
            tabbedPane.paint(g2);
          }
          return Printable.PAGE_EXISTS;
        }
      });

      if (pj.printDialog() == false)
      return;

      try 
      {
        pj.print();
        msgLabel.setText("  Printing your file...");
      } 

      catch (PrinterException ex) 
      {
        msgLabel.setText("  Sorry something went wrong, cannot print the file at the moment.");
      }
    }
  }
  
  private void saveFile()
  {    
    if(tabIdx <= 0)
    {
      msgLabel.setText("  There are no drawings to save.");
    }
    
    else 
    {
      int returnVal = fc.showDialog(null, "Save");
      
      try 
      {
        if (returnVal == JFileChooser.APPROVE_OPTION) 
        {          
          fc.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
          BufferedImage bImg = new BufferedImage(1080, 500, BufferedImage.TYPE_INT_RGB);
          Graphics2D cg = bImg.createGraphics();
          tabbedPane.paint(cg);
          ImageIO.write(bImg, "png", new File(fc.getSelectedFile().getPath()));
          msgLabel.setText("  Saving your file...  ");
        } 

        else 
        {
          msgLabel.setText("  Save command cancelled by the user.");
        }
      }

      catch (IOException e) 
      {
        msgLabel.setText("  Sorry something went wrong, cannot save the file at the moment.");
      }
    }
  }
   
  /**
   * @param args the command line arguments
   */
  
  public static void main(String args[]) 
  {
    /* Set the Nimbus look and feel */
    //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
    /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
     */
    try {
      for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
        if ("metal".equals(info.getName())) {
          javax.swing.UIManager.setLookAndFeel(info.getClassName());
          break;
        }
      }
    } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | javax.swing.UnsupportedLookAndFeelException ex) {
      java.util.logging.Logger.getLogger(Drawing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    }
    //</editor-fold>
    
    //</editor-fold>

    /* Create and display the form */
    java.awt.EventQueue.invokeLater(new Runnable() 
    {
      @Override
      public void run()
      {            
        Drawing drg = new Drawing();
        drg.setVisible(true);
        drg.msgLabel.setText("  Drawing board is invisible. Select New from the File menu, to create new drawing");
      }
    });
  }

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JMenuItem InstrMenu;
  private javax.swing.JMenuItem aboutProgramMenu;
  private javax.swing.JMenuItem aboutProgrammerMenu;
  private javax.swing.JMenuItem arcMenu;
  private javax.swing.JButton brushBtn;
  private javax.swing.JLabel brushLabel;
  private javax.swing.JMenuItem brushMenu;
  private javax.swing.JSlider brushSlider;
  private javax.swing.JPanel btnPanel;
  private javax.swing.JMenuItem circleMenu;
  private javax.swing.JButton clearBtn;
  private javax.swing.JButton ellipseBtn;
  private javax.swing.JMenuItem ellipseMenu;
  private javax.swing.JMenuItem exitMenu;
  private javax.swing.JMenuItem featMenu;
  private javax.swing.JMenu fileMenu;
  private javax.swing.JButton fillBtn;
  private javax.swing.JMenu helpMenu;
  private javax.swing.JButton lineBtn;
  private javax.swing.JMenuItem lineMenu;
  private javax.swing.JMenuBar mainMenuBar;
  private javax.swing.JPanel mainPanel;
  private javax.swing.JSeparator middleSeparator;
  private javax.swing.JLabel msgLabel;
  private javax.swing.JMenuItem newMenu;
  private javax.swing.JMenuItem printFileMenu;
  private javax.swing.JMenu printMenu;
  private javax.swing.JButton rectBtn;
  private javax.swing.JMenuItem rectangleMenu;
  private javax.swing.JMenuItem roundRecMenu;
  private javax.swing.JMenuItem saveFileMenu;
  private javax.swing.JMenu saveMenu;
  private javax.swing.JMenu shapesMenu;
  private javax.swing.JButton strokeBtn;
  private javax.swing.JTabbedPane tabbedPane;
  private javax.swing.JSeparator topSeparator;
  private javax.swing.JLabel transLabel;
  private javax.swing.JSlider transSlider;
  private javax.swing.JMenuItem versionMenu;
  // End of variables declaration//GEN-END:variables
}
